#include <avr/io.h>
#include <stdint.h>            // has to be added to use uint8_t
#include <avr/interrupt.h>    // Needed to use interrupts
#include <Wire.h>
#include "RunningAverage.h"

unsigned long previousMillis = 0; // last time update
const int channel_a_enable  = 6;
const int channel_a_input_1 = 4;
const int channel_a_input_2 = 7;
const int channel_b_enable  = 5;
const int channel_b_input_3 = 3;
const int channel_b_input_4 = 2;
const int numReadings = 20;
int readings[numReadings];      // the readings from the analog input
int readIndex = 0;              // the index of the current reading
int total = 0;                  // the running total
int LightAverage = 0;                // the average

const int LightSensor = A0;
const int LedDay = A1;
const int LedNight = A2;
const int LedDusk = A3;
const int LedOpenMove = A4;
const int LedCloseMove = A5;

const byte OpenPin = 8;        // the number of the door high
const byte ClosePin = 9;        // the number of the door low
int HighState = 0;            // variable for reading the pushbutton status
int State = 0;                // shows present state
int NextState = 1;            // shows next state
int LightValue = analogRead(LightSensor);
RunningAverage myRA(10);
int samples = 0;
int Dusk=0;
int Night =0;
int Day =0;
int DoorOpen = 0;
int DoorClosed=0;
int DoorMiddle=0;
int DoorHigh=0;
int DoorLow=0;
int DoorSpeed=150;


void CheckStates()
{

    unsigned long currentMillis = millis();

    Serial.println( "Closed \tMiddle \tOpen \tDusk \tNight  \tDay  \tLow \tHigh \tTime  \tLight");
    Serial.print( DoorClosed);
    Serial.print( "\t");
    Serial.print( DoorMiddle);
    Serial.print( "\t");
    Serial.print( DoorOpen);
    Serial.print( "\t");
    Serial.print(Dusk);
    Serial.print( "\t");
    Serial.print(Night);
    Serial.print( "\t");
    Serial.print(Day);
    Serial.print( "\t"); 
    Serial.print(digitalRead(ClosePin) );
    Serial.print( "\t");
    Serial.print(digitalRead(OpenPin));
    Serial.print( "\t");
    Serial.print(currentMillis);
    Serial.print( "\t");
    Serial.println(LightAverage);
}
    

void moveup(int DoorSpeed)
{

  //Serial.print("  Should be moving Left  ");
   do
    {
  
  analogWrite( channel_a_enable, DoorSpeed);
  digitalWrite( channel_a_input_1, HIGH);
  digitalWrite( LedOpenMove , HIGH);
  digitalWrite( channel_a_input_2, LOW);
  delay(5);
  digitalWrite( LedOpenMove , LOW);
      } while (digitalRead(OpenPin) == HIGH);
      digitalWrite( LedOpenMove, LOW);
}


void movedown(int DoorSpeed)
{
  //Serial.print(" Should be moving Right ");
   do
    {
  analogWrite( channel_a_enable, DoorSpeed);
  digitalWrite( channel_a_input_1, LOW);
  digitalWrite(LedCloseMove , HIGH);
  digitalWrite( channel_a_input_2, HIGH);
  delay(5); 
   digitalWrite( LedCloseMove, LOW);
    } while (digitalRead(ClosePin) == HIGH);
     digitalWrite( LedCloseMove, LOW);
}

void DoorState()
        {
             DoorHigh=digitalRead(OpenPin);
             DoorLow=digitalRead(ClosePin);
            
            if (DoorHigh == 1 && DoorLow == 0)
            {
            DoorOpen = 0;
            DoorClosed=1;
            DoorMiddle=0;
            }

            if (DoorHigh == 1 && DoorLow == 1)
            {
            DoorOpen = 0;
            DoorClosed=0;
            DoorMiddle=1;
            }
            
            if (DoorHigh == 0 && DoorLow == 1)
            {
            DoorOpen = 1;
            DoorClosed=0;
            DoorMiddle=0;
            }

        }

void ReadLight()
{
  for (int thisReading = 0; thisReading < numReadings; thisReading++) {
       LightValue=analogRead(LightSensor);
       delay(10);
       myRA.addValue(LightValue);
       LightAverage=myRA.getAverage();
      
     myRA.clear();
    } 
    
     if ( LightAverage < 200 )
        {
        Dusk=0;
        Night=1;
        Day=0;
        }
      if ( LightAverage < 391 && LightAverage > 201)
        {
        Dusk=1;
        Night=0;
        Day=0;
        }
      if ( LightAverage > 392 )
        {
        Dusk=0;
        Night=0;
        Day=1;
        }
       digitalWrite(LedDay, Day);
       digitalWrite(LedDusk, Dusk);
       digitalWrite(LedNight, Night);
       
       
}


void allInputsOff()
{
  digitalWrite( 4, LOW );
  digitalWrite( 7, LOW );
  digitalWrite( 6, LOW );
  digitalWrite( 3, LOW );
  digitalWrite( 2, LOW );
  digitalWrite( 5, LOW );
}



void setup() {
    Serial.begin( 9600 );
    Serial.println("Boot");
    myRA.clear(); 


const int LedDay = A1;
const int LedNight = A2;
const int LedDusk = A3;
const int LedOpenMove = A4;
const int LedCloseMove = A5;


  
    
  // put your setup code here, to run once:
    pinMode( channel_a_enable, OUTPUT );  // Channel A enable
    pinMode( channel_a_input_1, OUTPUT ); // Channel A input 1
    pinMode( channel_a_input_2, OUTPUT ); // Channel A input 2
    pinMode( channel_b_enable, OUTPUT );  // Channel B enable
    pinMode( channel_b_input_3, OUTPUT ); // Channel B input 3
    pinMode( channel_b_input_4, OUTPUT ); // Channel B input 4
    pinMode(LedDay,OUTPUT);
    pinMode(LedNight,OUTPUT);
    pinMode(LedDusk,OUTPUT);
    pinMode(LedOpenMove,OUTPUT);
    pinMode(LedCloseMove,OUTPUT);
  
    digitalWrite(8, HIGH); // pinMode( ,INPUT_PULLUP ) is default
    digitalWrite(9, HIGH); // pinMode( ,INPUT_PULLUP ) is default
    pinMode(8, INPUT_PULLUP);
    pinMode(9, INPUT_PULLUP);


    digitalWrite( LedDay, HIGH);
    digitalWrite( LedNight, HIGH);
    digitalWrite( LedDusk, HIGH);
    digitalWrite( LedOpenMove, HIGH);
    digitalWrite( LedCloseMove, HIGH);
    delay(2000);
    digitalWrite( LedDay, LOW);
    delay(2000);
    digitalWrite( LedNight, LOW);
    delay(1000);
    digitalWrite( LedDusk, LOW);
    delay(1000);
    digitalWrite( LedOpenMove, LOW);
    delay(1000);
    digitalWrite( LedCloseMove, LOW);
    delay(2000);
   
    Serial.println("Starting up");
    ReadLight();
    DoorState();
    //CheckStates();
    delay(10000);
    
      // test for position - should be door closed
      if (DoorClosed == 1)
      {
      //Serial.println("Door Closed \t  startup \t All Good");
      }
  

      if (Dusk == 1 && DoorMiddle == 1)
      {
         // Serial.println("Door  middle \t its dusk \t  open door");
          moveup(DoorSpeed);
       }

       
        if (Day == 1 && DoorMiddle == 1)
        {       
        // Serial.println("Door  middle \t  its day \t Shut door");
         movedown(DoorSpeed);
        }
        
        if (Night == 1 && DoorMiddle == 1)
         {       
        // Serial.println("Door  middle \t  its Night \t Shut door");
         movedown(DoorSpeed);
        }
        
    
      
        if (Dusk == 1 && DoorOpen == 1)
        {
        // Serial.println("Door Open \t  dusk \t leave open");
         }

         if (Night == 1 && DoorOpen == 1)
        {
        // Serial.println("Door Open \t  its Night Shut it");
         movedown(DoorSpeed);
         }

          if (Day == 1 && DoorOpen == 1)
        {
         //Serial.println(" Door  Open  \t   Day \t Shut it");
         movedown(DoorSpeed);
         }
  } 


void loop() {

  unsigned long currentMillis = millis();
  ReadLight();
  DoorState();
  CheckStates();
  delay(1000);
  
  if (DoorMiddle == 1)
      {
      //Serial.print(" Door is inbetween ");
      ReadLight();
      if (Dusk==1){
         moveup(DoorSpeed);
      }
      else
      {
         movedown(DoorSpeed);
      }
      
  }

     
  if( Dusk ==  1 && DoorClosed == 1)
  {
         
         moveup(DoorSpeed);
  }

if( Night ==  1 && DoorOpen == 1)
  {
      
         movedown(DoorSpeed);
  }

if( Day ==  1 && DoorOpen == 1)
  {

         movedown(DoorSpeed);
  }

  allInputsOff();

}







